package com.catalpa.commons.mojo;

import com.baomidou.mybatisplus.annotation.DbType;
import com.catalpa.commons.dto.GeneratorDto;
import com.catalpa.commons.utils.GeneratorUtil;
import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;
import org.apache.maven.plugins.annotations.Mojo;
import org.apache.maven.plugins.annotations.Parameter;

/**
 * @author zjwu
 * MySQL代码生成器
 */
@Mojo(name = "MySQLGeneratorMojo")
public class GeneratorMojo extends AbstractMojo {

    /**
     * 数据库名称
     */
    @Parameter(name = "databaseName")
    private String databaseName;

    /**
     * 表名称
     */
    @Parameter(name = "tableName")
    private String tableName;

    /**
     * 数据库ip
     */
    @Parameter(name = "ip")
    private String ip;

    /**
     * 数据库端口号
     */
    @Parameter(name = "port")
    private String port;

    /**
     * 数据库用户名
     */
    @Parameter(name = "userName")
    private String userName;

    /**
     * 数据库用户密码
     */
    @Parameter(name = "userPassword")
    private String userPassword;

    /**
     * 作者
     */
    @Parameter(name = "author")
    private String author;

    /**
     * 输出路径
     */
    @Parameter(name = "outputDir")
    private String outputDir;

    /**
     * 父包名
     */
    @Parameter(name = "parent")
    private String parent;

    /**
     * 实体类包名
     */
    @Parameter(name = "entity")
    private String entity;

    /**
     * 控制类包名
     */
    @Parameter(name = "controller")
    private String controller;

    /**
     * 服务类包名
     */
    @Parameter(name = "service")
    private String service;

    /**
     * 服务实现类包名
     */
    @Parameter(name = "serviceImpl")
    private String serviceImpl;

    /**
     * 映射类包名
     */
    @Parameter(name = "mapper")
    private String mapper;

    /**
     * 映射类XML包名
     */
    @Parameter(name = "xml")
    private String xml;

    /**
     * 传输类包名
     */
    @Parameter(name = "dto")
    private String dto;

    /**
     * 是否覆盖已生成文件
     */
    @Parameter(name = "override")
    private Boolean override;

    /**
     * 插件主方法
     *
     * @throws MojoExecutionException
     * @throws MojoFailureException
     */
    public void execute() throws MojoExecutionException, MojoFailureException {
        GeneratorDto generatorDto = new GeneratorDto();
        generatorDto.setIp(ip);
        generatorDto.setPort(port);
        generatorDto.setDto(dto);
        generatorDto.setAuthor(author);
        generatorDto.setEntity(entity);
        generatorDto.setController(controller);
        generatorDto.setMapper(mapper);
        generatorDto.setOverride(override);
        generatorDto.setParent(parent);
        generatorDto.setService(service);
        generatorDto.setServiceImpl(serviceImpl);
        generatorDto.setDatabaseName(databaseName);
        generatorDto.setXml(xml);
        generatorDto.setOutputDir(outputDir);
        generatorDto.setUserName(userName);
        generatorDto.setUserPassword(userPassword);
        generatorDto.setTableName(tableName);
        generatorDto.setDatabaseType(DbType.MYSQL.getDb());
        new GeneratorUtil(generatorDto).generate();
    }

}
